diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/traps.c linux-openmosix/arch/i386/kernel/traps.c
--- linux/arch/i386/kernel/traps.c	2002-11-29 00:53:09.000000000 +0100
+++ linux-openmosix/arch/i386/kernel/traps.c	2004-02-05 10:50:55.000000000 +0100
@@ -50,6 +50,11 @@
 #include <linux/irq.h>
 #include <linux/module.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#include <asm/processor.h>
+#endif /* CONFIG_MOSIX */
+
 asmlinkage int system_call(void);
 asmlinkage void lcall7(void);
 asmlinkage void lcall27(void);
@@ -388,7 +393,11 @@
 DO_VM86_ERROR( 3, SIGTRAP, "int3", int3)
 DO_VM86_ERROR( 4, SIGSEGV, "overflow", overflow)
 DO_VM86_ERROR( 5, SIGSEGV, "bounds", bounds)
+#ifdef CONFIG_MOSIX
+DO_ERROR_INFO( 6, SIGILL,  "invalid operand", real_invalid_op, ILL_ILLOPN, regs->eip)
+#else
 DO_ERROR_INFO( 6, SIGILL,  "invalid operand", invalid_op, ILL_ILLOPN, regs->eip)
+#endif /* CONFIG_MOSIX */
 DO_VM86_ERROR( 7, SIGSEGV, "device not available", device_not_available)
 DO_ERROR( 8, SIGSEGV, "double fault", double_fault)
 DO_ERROR( 9, SIGFPE,  "coprocessor segment overrun", coprocessor_segment_overrun)
@@ -405,6 +414,24 @@
 	if (!(regs->xcs & 3))
 		goto gp_in_kernel;
 
+#ifdef CONFIG_MOSIX
+	if(error_code == 0 && (current->mosix.dflags & DREMOTE))
+	{
+		short code;
+		u64 clk;
+
+		if(!get_user(code, (short *)regs->eip) &&
+			code == 0x310F) /* RDTSC */
+		{
+			clk = mosix_remote_tsc();
+			regs->eax = clk & 0xffffffff;
+			regs->edx = clk >> 32;
+			regs->eip += 2;
+			return;
+		}
+		mosix_go_home(0);
+	}
+#endif /* CONFIG_MOSIX */
 	current->thread.error_code = error_code;
 	current->thread.trap_no = 13;
 	force_sig(SIGSEGV, current);
@@ -501,6 +528,30 @@
 	inb(0x71);		/* dummy */
 }
 
+
+#ifdef CONFIG_MOSIX
+static __u32 user_features[NCAPINTS] = USER_MODE_FEATURES;
+
+asmlinkage void
+do_invalid_op(struct pt_regs * regs, long error_code)
+{
+	if((current->mosix.dflags & DREMOTE) && !(regs->eflags & VM_MASK) &&
+							(regs->xcs & 3) == 3)
+	{
+		int i;
+
+		for(i = 0 ; i < NCAPINTS ; i++)
+		if(current->mosix.features[i] & user_features[i] &
+					~boot_cpu_data.x86_capability[i])
+		{
+			mosix_go_home(0);	/* no return if successful */
+			break;
+		}
+	}
+	do_real_invalid_op(regs, error_code);
+}
+#endif /* CONFIG_MOSIX */
+
 /*
  * Our handling of the processor debug registers is non-trivial.
  * We do not clear them on entry and exit from the kernel. Therefore
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/kernel/vm86.c linux-openmosix/arch/i386/kernel/vm86.c
--- linux/arch/i386/kernel/vm86.c	2003-08-25 13:44:39.000000000 +0200
+++ linux-openmosix/arch/i386/kernel/vm86.c	2004-02-05 10:50:55.000000000 +0100
@@ -27,7 +27,9 @@
  *                instead of returning to userspace. This simplifies
  *                do_int, and is needed by handle_vm6_fault. Kasper
  *                Dupont <kasperd@daimi.au.dk>
- *   
+ *  
+ *   Oct 7 2003 - Unfixed ptrace bug fix for 2.4.19
+		  Moshe Bar <moshe@moshebar.com> 
  */
 
 #include <linux/errno.h>
@@ -45,6 +47,10 @@
 #include <asm/io.h>
 #include <asm/irq.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 /*
  * Known problems:
  *
@@ -97,6 +103,10 @@
 	struct pt_regs *ret;
 	unsigned long tmp;
 
+#ifdef CONFIG_MOSIX
+	if(current->mosix.dflags & DREMOTE)
+		panic("remote save_v86");
+#endif /* CONFIG_MOSIX */
 	if (!current->thread.vm86_info) {
 		printk("no vm86_info: BAD\n");
 		do_exit(SIGSEGV);
@@ -111,9 +121,18 @@
 		do_exit(SIGSEGV);
 	}
 	tss = init_tss + smp_processor_id();
+#ifdef CONFIG_MOSIX
+	lock_mosix();	/* ptrace checks saved_esp0 under the mosix-lock */
+#endif /* CONFIG_MOSIX */
 	tss->esp0 = current->thread.esp0 = current->thread.saved_esp0;
 	current->thread.saved_esp0 = 0;
 	ret = KVM86->regs32;
+#ifdef CONFIG_MOSIX
+	unlock_mosix();
+	task_lock(current);
+	current->mosix.stay &= ~DSTAY_FOR_86;
+	task_unlock(current);
+#endif /* CONFIG_MOSIX */
 	return ret;
 }
 
@@ -167,6 +186,13 @@
 	struct task_struct *tsk;
 	int tmp, ret = -EPERM;
 
+#ifdef CONFIG_MOSIX
+	if(!mosix_go_home_for_reason(1, DSTAY_FOR_86))
+	{
+		ret = -ENOMEM;
+		goto out;
+	}
+#endif /* CONFIG_MOSIX */
 	tsk = current;
 	if (tsk->thread.saved_esp0)
 		goto out;
@@ -224,6 +250,13 @@
 	ret = -EFAULT;
 	if (tmp)
 		goto out;
+#ifdef CONFIG_MOSIX
+	if(!mosix_go_home_for_reason(1, DSTAY_FOR_86))
+	{
+		ret = -ENOMEM;
+		goto out;
+	}
+#endif /* CONFIG_MOSIX */
 	info.regs32 = (struct pt_regs *) &subfunction;
 	info.vm86plus.is_vm86pus = 1;
 	tsk->thread.vm86_info = (struct vm86_struct *)v86;
@@ -276,9 +309,15 @@
  * Save old state, set default return value (%eax) to 0
  */
 	info->regs32->eax = 0;
+#ifdef CONFIG_MOSIX
+	lock_mosix();
+#endif /* CONFIG_MOSIX */
 	tsk->thread.saved_esp0 = tsk->thread.esp0;
 	tss = init_tss + smp_processor_id();
 	tss->esp0 = tsk->thread.esp0 = (unsigned long) &info->VM86_TSS_ESP0;
+#ifdef CONFIG_MOSIX
+	unlock_mosix();
+#endif /* CONFIG_MOSIX */
 
 	tsk->thread.screen_bitmap = info->screen_bitmap;
 	if (info->flags & VM86_SCREEN_BITMAP)
@@ -298,6 +337,11 @@
 
 	regs32 = save_v86_state(regs16);
 	regs32->eax = retval;
+#ifdef CONFIG_MOSIX
+	task_lock(current);
+	current->mosix.stay &= ~DSTAY_FOR_86;
+	task_unlock(current);
+#endif /* CONFIG_MOSIX */
 	__asm__ __volatile__("movl %0,%%esp\n\t"
 		"jmp ret_from_sys_call"
 		: : "r" (regs32), "b" (current));
@@ -706,7 +750,11 @@
 	int ret = 0;
 
 	read_lock(&tasklist_lock);
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
 	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if ((p == tsk) && (p->sig)) {
 			ret = 1;
 			break;
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/lib/usercopy.c linux-openmosix/arch/i386/lib/usercopy.c
--- linux/arch/i386/lib/usercopy.c	2003-06-13 16:51:29.000000000 +0200
+++ linux-openmosix/arch/i386/lib/usercopy.c	2004-02-05 10:50:55.000000000 +0100
@@ -119,6 +119,11 @@
 __strncpy_from_user(char *dst, const char *src, long count)
 {
 	long res;
+
+#ifdef CONFIG_MOSIX
+	if(USER_IS_REMOTE)
+		return(deputy_strncpy_from_user(dst, (char *)src, count, 0));
+#endif /* CONFIG_MOSIX */
 	__do_strncpy_from_user(dst, src, count, res);
 	return res;
 }
@@ -145,6 +150,11 @@
 strncpy_from_user(char *dst, const char *src, long count)
 {
 	long res = -EFAULT;
+
+#ifdef CONFIG_MOSIX
+	if(USER_IS_REMOTE)
+		return(deputy_strncpy_from_user(dst, (char *)src, count, 1));
+#endif /* CONFIG_MOSIX */
 	if (access_ok(VERIFY_READ, src, 1))
 		__do_strncpy_from_user(dst, src, count, res);
 	return res;
@@ -189,6 +199,10 @@
 unsigned long
 clear_user(void *to, unsigned long n)
 {
+#ifdef CONFIG_MOSIX
+	if (USER_IS_REMOTE)
+		return(deputy_clear_user(to, n, 1));
+#endif /* CONFIG_MOSIX */
 	if (access_ok(VERIFY_WRITE, to, n))
 		__do_clear_user(to, n);
 	return n;
@@ -208,6 +222,10 @@
 unsigned long
 __clear_user(void *to, unsigned long n)
 {
+#ifdef CONFIG_MOSIX
+	if (USER_IS_REMOTE)
+		return(deputy_clear_user(to, n, 0));
+#endif /* CONFIG_MOSIX */
 	__do_clear_user(to, n);
 	return n;
 }
@@ -228,6 +246,10 @@
 	unsigned long mask = -__addr_ok(s);
 	unsigned long res, tmp;
 
+#ifdef CONFIG_MOSIX
+	if(USER_IS_REMOTE)
+		return(deputy_strnlen_user((char *)s, n));
+#endif /* CONFIG_MOSIX */
 	__asm__ __volatile__(
 		"	testl %0, %0\n"
 		"	jz 3f\n"
diff -Naur --exclude=CVS --exclude=configs linux/arch/i386/mm/fault.c linux-openmosix/arch/i386/mm/fault.c
--- linux/arch/i386/mm/fault.c	2002-11-29 00:53:09.000000000 +0100
+++ linux-openmosix/arch/i386/mm/fault.c	2004-02-05 10:50:56.000000000 +0100
@@ -25,6 +25,10 @@
 #include <asm/pgalloc.h>
 #include <asm/hardirq.h>
 
+#ifdef CONFIG_MOSIX
+#include <linux/hpc.h>
+#endif /* CONFIG_MOSIX */
+
 extern void die(const char *,struct pt_regs *,long);
 
 /*
@@ -38,6 +42,10 @@
 	if (!size)
 		return 1;
 
+#ifdef CONFIG_MOSIX
+	if(USER_IS_REMOTE)
+		return(deputy_verify_write((void *)addr, size));
+#endif /* CONFIG_MOSIX */
 	vma = find_vma(current->mm, start);
 	if (!vma)
 		goto bad_area;
@@ -127,6 +135,7 @@
 asmlinkage void do_invalid_op(struct pt_regs *, unsigned long);
 extern unsigned long idt;
 
+
 /*
  * This routine handles page faults.  It determines the address,
  * and the problem, and then passes it off to one of the appropriate
diff -Naur --exclude=CVS --exclude=configs linux/arch/ia64/kernel/entry.S linux-openmosix/arch/ia64/kernel/entry.S
--- linux/arch/ia64/kernel/entry.S	2003-11-28 19:26:19.000000000 +0100
+++ linux-openmosix/arch/ia64/kernel/entry.S	2004-02-05 10:50:56.000000000 +0100
@@ -41,6 +41,10 @@
 #include <asm/unistd.h>
 #include <asm/asmmacro.h>
 #include <asm/pgtable.h>
+#ifdef CONFIG_OMIA64
+#include "mosia64asm.H"
+#endif /* CONFIGR_OMIA64 */
+
 
 #include "minstate.h"
 
diff -Naur --exclude=CVS --exclude=configs linux/Documentation/Configure.help linux-openmosix/Documentation/Configure.help
--- linux/Documentation/Configure.help	2003-11-28 19:26:19.000000000 +0100
+++ linux-openmosix/Documentation/Configure.help	2004-02-05 10:50:52.000000000 +0100
@@ -100,6 +100,181 @@
   like MGA monitors that you are very unlikely to see on today's
   systems.
 
+openMosix extensions
+CONFIG_MOSIX
+  Say Y to support process migration and automatic load-balancing
+  within a cluster.
+
+Support clusters with a complex network topology
+CONFIG_MOSIX_TOPOLOGY
+  This option is intended for configurations where the network
+  "distance" between the nodes is not uniform, so you require
+  node-dependent fine-tuning (see "man tune").
+
+  If all the nodes in your openMosix cluster are connected via a simple
+  network and use the same networking hardware (which is the more
+  common case), Say N here (and save kernel-time!).
+
+  Say Y here if not all your openMosix cluster is connected via a simple
+  network or if some nodes use significantly different networking
+  hardware (if you are not sure whether the difference is significant,
+  compile some openMosix kernel anyway and compare the results of "tune").
+
+Maximum network-topology complexity to support
+CONFIG_MOSIX_MAXTOPOLOGY
+  In a complex network-toplogy, each node can identify a number of
+  subsets of the other nodes, each set having the same networking
+  hardware, the same processor type (perhaps slower or faster, but
+  of the same type) and the same routing path.
+  The maximum network-complexity is defined as the maximum number of
+  those sets over all the nodes in your cluster.  minimizing this
+  number helps saving kernel time and inter-node communication, so
+  please use only the level of complexity that you actually need.
+
+  IMPORTANT NOTE: even if you prepare different kernels for different
+  nodes, all the nodes in your cluster must have the same value
+  configured here.
+
+  openMosix allows this value to be in the range of 2-10 (higher values
+  will be truncated and lower values imply no complex topology).
+
+
+openMosix diagnostics
+CONFIG_MOSIX_DIAG
+  Say Y to include openMosix consistency checks.
+  While this adds code to the kernel, it may prevent unexpected
+  occurences when running new versions of openMosix.
+
+
+Process arrival messages
+CONFIG_MOSIX_WEEEEEEEEE
+  If you say Y to this option, the console will display messages whenever
+  a process arrives: Weeeeeeeee..... for remote (guest) processes and
+  Wooooooooo..... for local processes returning home.
+
+Loopback process-migration testing
+CONFIG_MOSIX_CHEAT_MIGSELF
+  Say Y to allow loopback process "migration" from a node into itself
+  (useful only for kernel-debugging).
+
+Level of process-identity disclosure
+CONFIG_MOSIX_DISCLOSURE
+  Determine how much information about processes is disclosed by default
+  when they run as guests on remote nodes:
+  0 = no information
+  1 = only PID (and TGID if different)
+  2 = PID(/TGID), UID, GID
+  3 = PID(/TGID), UID, GID, PGRP, SESSION, COMMAND
+  Processes may modify this default by writing to /proc/self/disclosure.
+
+Prevent the "-openmosix" extension on kernel name
+CONFIG_MOSIX_EXTMOSIX
+  Say Y if you want the kernel and module directory to have the "-openMosix"
+  extension (to distinguish it from coexistant non-MOSIX kernels of the
+  same kernel version number).
+
+Stricter security on openMosix ports
+CONFIG_MOSIX_SECUREPORTS
+  The internal kernel TCP/UDP ports used by openMosix may not be accessed
+  by normal users (and even the Super-User has no real reason to access
+  them).  The question arises whether to allow user-connections to those
+  ports on other (internet) nodes, outside the cluster.
+  If routing schemes allow a openMosix node to also be accessed from within
+  the cluster using an IP address that is not listed in the openMosix
+  configuration, you must say Y (or risk that a hacking user will mess
+  with the openMosix internals by connecting to that IP address and one of
+  the openMosix port numbers).  However, these port numbers, though not
+  listed in "/etc/services", may be in use for other purposes somewhere
+  else on the internet - and this option would prevent accessing them,
+  so if your users require such access, say N and make sure that all the
+  IP addresses by which your nodes can be reached are listed as aliases
+  in the openMosix configuration.
+
+Direct File-System Access for openMosix
+CONFIG_MOSIX_DFSA
+  Direct File System Access:
+  DFSA is now ready for Beta-testing.  It can currently only be used
+  by oMFS (openMosix File-System).  You may be interested in this option
+  if you either like experimenting and experiencing the power of DFSA
+  with MFS, or if you are interested in either developing a new
+  file-system, or adapting an existing one to DFSA.
+
+  For the lay user, all you need is to also configure MFS, then run
+  the following commands on each node:
+      mkdir /mfs
+      mount -t mfs cluster /mfs -odfsa=1
+
+  If you are more serious about it, please read "Documentation/DFSA"
+  or run "man dfsa".
+
+openMosix File-System
+CONFIG_MOSIX_FS
+  The openMosix File-System (oMFS) is now ready for Beta-testing.
+  Along with DFSA, it forms the basis for the next generation
+  of openMosix, expanding the power of openMosix beyond CPU-bound tasks
+  into I/O tasks as well.
+
+  On its own, oMFS allows processes to access most files (more accurately,
+  all regular files, directories and symbolic-links, but excluding the
+  "/proc" file-system and oMFS itself) on all the nodes in the cluster.
+
+  oMFS assumes that all users/group-ID's throughout the cluster are
+  equivalent: if this is not the case, you cannot use oMFS, so you must
+  say 'N' here, unless you have a sub-cluster where the user/group-ID's
+  are equivalent, in which case you may still choose to configure MFS
+  only in that sub-cluster.
+
+  To use oMFS, all you need is to type:
+        mount -t mfs cluster /mfs
+  (the word "cluster" can be changed to suit your taste and the "/mfs"
+  mount-point is only a suggestion, to be used in this discussion).
+  For a permanent solution, enter the following line in "/etc/fstab":
+        cluster    /mfs    mfs    defaults    0 0
+
+  You can now access each node via "/mfs/{node_number}", you may also
+  access the following useful directories:
+
+  /mfs/here     - The current node where your process runs
+  /mfs/home     - Your home node
+  /mfs/magic    - The current node when used by the "creat" system call
+                  (or an "open" with the "O_CREAT" option) - otherwise,
+                  the last node on which an MFS magical file was
+                  successfully created (this is very useful for creating
+                  temporary-files, then immediately unlinking them)
+  /mfs/lastexec - The node on which the process last issued a successful
+                  "execve" system-call.
+  /mfs/selected - The node you selected by either your process itself or
+                  one of its ancesstors (before forking this process),
+                  writing a number into "/proc/self/selected".
+
+  MFS is currently the only file-system that can be used with DFSA.
+  Detailed technical information is available in
+  "Documentation/filesystems/mfs.txt".
+
+Poll/Select exceptions on pipes
+CONFIG_MOSIX_PIPE_EXCEPTIONS
+  This feature is not required for MOSIX-proper, but some user-mode
+  programs like it.  It allows a program to be notified when someone
+  is wishing to read from a pipe.  If you say Y, you may then use:
+  ioctl(pipefd, TCSBRK, arg) to set or clear exception conditions.
+  If (arg & 1), an exception is generated when someone is trying to
+  read the pipe.  If (arg & 2), an exception is generated when the
+  pipe has no more readers.  The default is that pipes never generate
+  any exceptions.  An exception can be returned by the "select" system
+  call and will also cause POLLPRI to be included in the return-value
+  of the "poll" system-call.  You can also get an under-estimate of the
+  number of bytes that processes curretly try to read from the pipe using
+  ioctl(pipefd, TIOCGWINSZ, 0).
+
+Disable OOM (out of memory killer)
+CONFIG_MOSIX_NO_OOM
+   This feature allows you to turn off the abominevolous out of memory killer
+   recently re-introduced into ther Linux kernel. Because the kernel does
+   over-commit memory (which could be avoided altogether) when all processes
+   belonging to a process are required to return to that node, there might be
+   a shortage of RAM + Swapspace to accomdate them all and then the OOM killer
+   kicks in. Turn this feature on to avoid using the OOM killer.
+
 Prompt for advanced kernel configuration options
 CONFIG_ADVANCED_OPTIONS
   This option will enable prompting for a variety of advanced kernel
diff -Naur --exclude=CVS --exclude=configs linux/Documentation/DFSA linux-openmosix/Documentation/DFSA
--- linux/Documentation/DFSA	1970-01-01 01:00:00.000000000 +0100
+++ linux-openmosix/Documentation/DFSA	2002-05-19 16:39:21.000000000 +0200
@@ -0,0 +1,215 @@
+DFSA - Direct File-System Access:
+
+The first generation of openMosix has brought about great performance
+improvements in CPU jobs - "number crunchers", but cannot help in the
+case of I/O tasks, which need to communicate with their home-node as
+often as every system-call, and are therefore better off remaining there.
+
+The second generation of openMosix, includes DFSA, whereby the more common
+system-calls can be (under certain conditions) performed directly on the
+caller's current node, thus increasing the benefit and probability that
+I/O-oriented (or mixed I/O and CPU) tasks will also migrate.
+
+DFSA operates over suitable, cluster-wide shared file-systems that fulfill
+certain requirements.  The only file-system to currently fulfill those
+requirements is the openMosix File-System (MFS).
+
+To use DFSA without violating access permissions, the permission-scheme
+(user and group ID's) must be identical, or at least compatible throughout
+the openMosix cluster.
+
+Each partition that is to operate in DFSA mode must be assigned a unique
+DFSA index, currently in the range of 1-8, that must be identical on all
+the nodes in the openMosix cluster.
+
+To request a particular partition to operate in DFSA mode, mount (or remount)
+it with the "-odfsa={n}" argument  (1 <= n <= 8).
+
+You should do the same on all the nodes in the cluster either at about the
+same time or before openMosix is configured: failure to assign all DFSA
+mount-points on some of the nodes is not fatal, but may result in serious
+performance degradation, while simultaneous use of the same index for
+different partitions, is likely to cause various faults.
+
+To disassociate a partition from DFSA, run:
+
+mount -o remount {mount-point} -odfsa=0.
+
+You may also designate symbolic-links to operate in DFSA mode: this is
+equivalent to a declaration that the given links are identical on all
+nodes and point to the same partition.  It saves remote processes who use
+those link(s) the need to contact their home node every use in order to
+read those links.  To declare a symbolic-link as identical, type:
+
+echo {symbolic-link} > /proc/hpc/admin/dfsalinks,
+
+where the symbolic-link must be an absolute-pathname, pointing at an existing
+file (or directory or another symbolic-link) on an already-mounted partition
+that is capable of DFSA (but it is not required to be already associated with
+a DFSA index).
+
+To remove a symbolic-link declaration, type:
+
+echo -{symbolic-link} > /proc/hpc/admin/dfsalinks:
+
+If you intend to re-define a declared symbolic link, you must first re-
+move its declaration, then re-declare after the change is made.
+
+To see a list of all currently-declared symbolic links, type:
+
+cat /proc/hpc/admin/dfsalinks.
+
+To cancel all symbolic-link declarations, type:
+
+echo - > /proc/hpc/admin/dfsalinks.
+
+The number of declared symbolic-links is currently limited to 8 and their
+path-name length is limited to 128 characters.
+
+requirements from a complying file-system:
+------------------------------------------
+1) all operations on the file system must be synchronous, in the sense that
+   there is [at most] only one buffer/inode cache throughout the cluster.
+   (on client-server file-systems, this usually means that the whole cache
+   is maintained on the server - however, a sophisticated server may "lend"
+   the cache of particular inodes to particular clients at any given time.
+   on shared-hardware file-systems, this probably requires either a hardware
+   invalidation signal or a new version to be marked on each inode after each
+   modification).
+
+2) The time-stamps on files and between files of the same file-system must be
+   consistent and advancing (unless the clock is deliberately set backwards),
+   regardless from which node modifications are made.
+
+3) The file-system must populate the following two new super-block methods:
+   a) "identify":
+       Given a "dentry", encapsulate identifying information about it into
+       a finite, rather-small structure, in a way that is sufficient to be
+       able to re-establish that open file/directory on another node.
+   b) "reconstruct":
+       Given only a mount-structure ("vfsmnt") and information that was
+       provided by "identify", produce a live new "dentry".
+
+       Also, while not enforced by DFSA itself, in order for the getcwd
+       system-call to work correctly on a shared file-system, regardless
+       of where the call is made from, it is also highly recommended to
+       populate the following new inode-method:
+   c) "checkpath":
+       Given a "dentry", ensure that following its path via the "dcache"
+       will truly reflect its current position on the shared file-system -
+       and if not, make the necessary fixes by adjusting the "dentry" around
+       the directory cache: The "dcache" of shared file-systems cannot be
+       trusted, since processes running on other nodes can move (or remove)
+       a directory at any time.
+
+4) The file-system must ensure that files/directories are not cleared when
+   unlinked, for as long as any process in the cluster still holds them open.
+   There are several possible techniques to achieve this, but given the
+   distributed nature of the file-system, some form of garbage-collection
+   is probably also called upon.
+
+Which system-calls are supported:
+---------------------------------
+The following system-calls are normally supported and usually run directly
+by the process, while any other calls, or hard cases still need to go via
+the home-node:
+
+	read, readv, write, writev, readahead
+	lseek, llseek
+	open, creat, close
+	dup, dup2, fcntl/fcntl64 (F_DUPFD,F_GETFL,F_SETFL)
+	getdents, getdents64, old_readdir
+	fsync, fdatasync
+	chdir, fchdir, getcwd
+	stat, stat64, newstat, lstat, lstat64, newlstat,
+	fstat, fstat64, newfstat
+	access
+	truncate, truncate64, ftruncate, ftruncate64
+	chmod, chown, chown16, lchown, lchown16, fchmod, fchown, fchown16
+	utime, utimes
+	symlink, readlink
+	mkdir, rmdir
+	link, unlink, rename
+
+Examples of hard cases:
+* if not all nodes have the same mounted DFSA partitions, or they do -
+  but with different mount-flags.
+* if the calling process is being traced.
+* if the process has a non-standard root-directory.
+* If the calling process has an emulating personality that causes it
+  to use an alternate root (but this is currently not relevant for the
+  i386 architecture).
+* if the calling process shares either its files or current directory
+  as a result of the "clone" system-call.
+* operations occuring during re-configuration of DFSA on either the
+  home-node or the node where the process runs.
+* operations involving special files (eg. other than regular, directories
+  or symbolic-links)
+* operations on files that were commonly opened and still shared with other
+  related processes.
+* dup2, where the second file-descriptor is an already open non-DFSA file
+  (that requires closing).
+* chdir/fchdir when the previous directory is non-DFSA.
+* link/rename that fail due to an attempt to cross-device link.
+* open/dup/dup2/fcntl(F_DUPFD) that requires an allowable-increase in
+  the maximal file-descriptor index (initially 1023!).
+* When the home-node has pending requests for the process (such as
+  signals, requests for "ps" information, request to migrate or consider
+  migration, etc.)
+* Use of path-names that leave the DFSA partition, as demonstrated by
+  the following example:
+	"/mfs" is a DFSA file-system
+	/mfstmp is a symbolic link to /mfs/2/tmp, and is declared in
+		/proc/hpc/admin/dfsalinks.
+	/mtmp is a symbolic link to /mfstmp, and is declared in
+		/proc/hpc/admin/dfsalinks.
+	/mfs2 is a symbolic link to /mfs/2, but is not declared.
+	on node #2, /fie is a symbolic link to "/tmp/foo".
+  then the following are accepted as simple cases (and identical):
+	/mfs/2/tmp/foo
+	//mfs//2/tmp/foo
+	/./mfs/2/tmp/foo
+	/mfstmp/foo
+	/mtmp/foo
+	/mfs/2/fie
+	mfs/2/tmp/foo  (when in the root directory)
+	
+  but not the following:
+	/tmp/../mfs/tmp/foo
+		(the kernel is not allowed to assume that each node has an
+		 accessible "/tmp" directory!)
+	/mfs/2/../../mfs/2/tmp/foo
+		(the secon ".." steps out of the "/mfs" DFSA partition)
+        /mfs2/tmp/foo
+		(/mfs2 is not declared, hence no assurance was provided
+		that it is identical on all nodes)
+	mfstmp/foo (or mfstmp/foo) when in the root directory
+		(just a difficult case to recognize)
+
+* when the home-node DEPUTY has pending requests for the process (such as
+  signals, requests for "ps" information, request to migrate or consider
+  migration, etc.)
+
+Deviations from normal Linux/Unix/Posix behavior:
+--------------------------------------------------
+It was impossible to maintain 100% compatibility on DFSA file-systems,
+but the deviations are kept to the very minimum:
+
+* A process that received a signal may continue running a few DFSA system-calls
+  before it actually receives and handles the signal.
+  (in contrast, any POSIX process that receives a signal may possibly
+   complete the next system-call, but cannot issue any new ones beyond that).
+
+* Simultaneous mapping and I/O on the same DFSA file creates unpredictable
+  results as follows:
+  1) execution (and library and all other file-mappings) is not always
+     protected against other process(es) modifying the file: either the
+     writing-process or the executing/mapping process may fail to receive the
+     "ETXTBSY" error.
+  2) The "MS_INVALIDATE" flag of "msync" may fail to ensure that previous
+     "write"(s) to a mapped DFSA file are discarded.
+  3) when a process modifies memory that is mapped as "MAP_SHARED" to a DFSA
+     file, but has not yet written it back (using "msync", "munmap", "exec"
+     or "exit"), it is possible that another process that reads that file as
+     it migrates will first see some of the changes but later (as opposed to
+     normal behavior), see the old values (or some of them) again.
diff -Naur --exclude=CVS --exclude=configs linux/Documentation/filesystems/00-INDEX linux-openmosix/Documentation/filesystems/00-INDEX
--- linux/Documentation/filesystems/00-INDEX	2002-11-29 00:53:08.000000000 +0100
+++ linux-openmosix/Documentation/filesystems/00-INDEX	2004-02-05 10:50:53.000000000 +0100
@@ -24,6 +24,8 @@
 	- info and mount options for the OS/2 HPFS.
 isofs.txt
 	- info and mount options for the ISO 9660 (CDROM) filesystem.
+mfs.txt
+        - info on the openMosix filesystem.
 jfs.txt
 	- info and mount options for the JFS filesystem.
 ncpfs.txt
diff -Naur --exclude=CVS --exclude=configs linux/drivers/char/mem.c linux-openmosix/drivers/char/mem.c
--- linux/drivers/char/mem.c	2003-11-28 19:26:20.000000000 +0100
+++ linux-openmosix/drivers/char/mem.c	2004-02-05 10:51:14.000000000 +0100
@@ -444,6 +444,9 @@
 	left = count;
 
 	/* do we want to be clever? Arbitrary cut-off */
+#ifdef CONFIG_MOSIX
+	if(!(current->mosix.dflags & DDEPUTY))
+#endif /* CONFIG_MOSIX */
 	if (count >= PAGE_SIZE*4) {
 		unsigned long partial;
 
@@ -528,6 +531,62 @@
 	return capable(CAP_SYS_RAWIO) ? 0 : -EPERM;
 }
 
+#ifdef CONFIG_MOSIX
+static ssize_t read_fun(struct file * file, char * buf, 
+			 size_t count, loff_t *ppos)
+{
+	unsigned long i, n = 0;
+
+	if (!count)
+		return 0;
+
+	if (!access_ok(VERIFY_WRITE, buf, count))
+		return -EFAULT;
+
+	while(count)
+	{
+		i = (count > 2*PAGE_SIZE ? 2*PAGE_SIZE : count);
+		if(copy_to_user(buf, current, i) < 0)
+			return(EFAULT);
+		buf += i;
+		count -= i;
+		n += i;
+	}
+	return(n);
+}
+
+static ssize_t write_fun(struct file * file, const char * buf, 
+			 size_t count, loff_t *ppos)
+{
+	unsigned long i, n = 0;
+	char *page;
+
+	if (!count)
+		return 0;
+
+	if (!access_ok(VERIFY_READ, buf, count))
+		return -EFAULT;
+
+	if (!(page = (char *)__get_free_page(GFP_KERNEL)))
+		return(-ENOMEM);
+
+	while(count)
+	{
+		i = (count > PAGE_SIZE ? PAGE_SIZE : count);
+		if(copy_from_user(page, (char *)buf, i) < 0)
+		{
+			free_page((long)page);
+			return(EFAULT);
+		}
+		buf += i;
+		count -= i;
+		n += i;
+	}
+	free_page((long)page);
+	return(n);
+}
+#endif /* CONFIG_MOSIX */
+
 struct page *kmem_vm_nopage(struct vm_area_struct *vma, unsigned long address, int write)
 {
 	unsigned long offset = vma->vm_pgoff << PAGE_SHIFT;
@@ -664,6 +723,13 @@
 	write:		write_full,
 };
 
+#ifdef CONFIG_MOSIX
+static struct file_operations fun_fops = {
+	read: read_fun,
+	write: write_fun,
+};
+#endif /* CONFIG_MOSIX */
+
 static int memory_open(struct inode * inode, struct file * filp)
 {
 	switch (MINOR(inode->i_rdev)) {
@@ -693,6 +759,11 @@
 		case 9:
 			filp->f_op = &urandom_fops;
 			break;
+#ifdef CONFIG_MOSIX
+		case 10:
+			filp->f_op = &fun_fops;
+			break;
+#endif /* CONFIG_MOSIX */
 		default:
 			return -ENXIO;
 	}
diff -Naur --exclude=CVS --exclude=configs linux/drivers/char/sysrq.c linux-openmosix/drivers/char/sysrq.c
--- linux/drivers/char/sysrq.c	2003-08-25 13:44:41.000000000 +0200
+++ linux-openmosix/drivers/char/sysrq.c	2004-02-05 10:51:14.000000000 +0100
@@ -288,7 +288,11 @@
 {
 	struct task_struct *p;
 
-	for_each_task(p) {
+#ifdef CONFIG_MOSIX
+	for_each_local_task(p) {
+#else
+  	for_each_task(p) {
+#endif /* CONFIG_MOSIX */
 		if (p->mm && p->pid != 1)
 			/* Not swapper, init nor kernel thread */
 			force_sig(sig, p);
